/* See "uuid-ossp-fix.c" for more information. */

/* Isn't case-sensitivity grand ;-) */

extern unsigned int uuid_LEN_BIN;
extern unsigned int uuid_LEN_STR;
extern unsigned int uuid_LEN_SIV;

extern unsigned int uuid_RC_OK;
extern unsigned int uuid_RC_ARG;
extern unsigned int uuid_RC_MEM;
extern unsigned int uuid_RC_SYS;
extern unsigned int uuid_RC_INT;
extern unsigned int uuid_RC_IMP;

extern unsigned int uuid_MAKE_V1;
extern unsigned int uuid_MAKE_V1MC;
extern unsigned int uuid_MAKE_V3;
extern unsigned int uuid_MAKE_V4;
extern unsigned int uuid_MAKE_V5;

extern unsigned int uuid_FMT_BIN;
extern unsigned int uuid_FMT_STR;
extern unsigned int uuid_FMT_TXT;
extern unsigned int uuid_FMT_SIV;

/* Actually enum but this will do */
typedef unsigned int uuid_rc_t;
typedef unsigned int uuid_fmt_t;

struct uuid_st;

/* UUID object handling */
extern uuid_rc_t uuid_create   (      struct uuid_st **_uuid);
extern uuid_rc_t uuid_destroy  (      struct uuid_st  *_uuid);
extern uuid_rc_t uuid_clone    (const struct uuid_st  *_uuid, struct uuid_st **_clone);

/* UUID generation */
extern uuid_rc_t uuid_load     (      struct uuid_st  *_uuid, const char *_name);
extern uuid_rc_t uuid_make     (      struct uuid_st  *_uuid, unsigned int _mode, ...);

/* UUID comparison */
extern uuid_rc_t uuid_isnil    (const struct uuid_st  *_uuid,                       int *_result);
extern uuid_rc_t uuid_compare  (const struct uuid_st  *_uuid, const struct uuid_st *_uuid2, int *_result);

/* UUID import/export */
extern uuid_rc_t uuid_import   (      struct uuid_st  *_uuid, uuid_fmt_t _fmt, const void  *_data_ptr, size_t  _data_len);
extern uuid_rc_t uuid_export   (const struct uuid_st  *_uuid, uuid_fmt_t _fmt,       void **_data_ptr, size_t *_data_len);

/* library utilities */
extern char         *uuid_error    (uuid_rc_t _rc);
extern unsigned long uuid_version  (void);
